package edu.uoc.android.uocapp.util;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
// Preparando para los proxys...
import org.apache.http.HttpHost;
import org.apache.http.conn.params.ConnRoutePNames;


import edu.uoc.android.uocapp.R;

import android.content.Context;
import android.util.Log;
import android.widget.Toast;

public class BrowserUOC {

	private String sPage = ""; // ltima pgina recibida
	private List<NameValuePair> lParametrosPost = null; // Parmetros para el POST
	private DefaultHttpClient httpclient = null;
	private Context mContext = null; // Por si tenemos que mandar mensajes de error a pantalla

	// Objetos comunes a todas las instancias
	private static String sUrl = ""; // Url a visitar
	private static List<Cookie> mCookies = new ArrayList<Cookie>();
	private static String sessionUOC = ""; // Variable de sesin de la UOC

	public BrowserUOC(Context contexto) {
		lParametrosPost = new ArrayList<NameValuePair>();
		httpclient = new DefaultHttpClient();
		mContext = contexto;		
	}

	public void setContexto(Context contexto) {
		mContext = contexto;
	}

	public void AddCookie(Cookie mC) {
		boolean yaExiste=false;
		String nombre=mC.getName();
		List<Cookie> mCookies2 = new ArrayList<Cookie>();;

		// Si la cookie ya la tenemos la sustituimos...
		for (Cookie cookie : mCookies){

			Cookie sessionInfo = cookie;
			if (sessionInfo.getName().equals(nombre))
			{
				Log.i("UOC","AddCookie: Cookie ya existe ("+nombre+")");
				mCookies2.add(mC);  // Ponemos la nueva
				yaExiste=true;			
			}
			else
			{
				mCookies2.add(sessionInfo);	// La dejamos como est			
			}

		}

		if (!yaExiste)
		{
			Log.i("UOC","AddCookie: Cookie nueva ("+nombre+")");
			mCookies2.add(mC);
		}		

		// Sustituimos...
		mCookies=mCookies2;

		Log.i("UOC","AddCookie: Total Cookies:"+mCookies.size());			
	}

	public void setAlmacenCookies(BasicCookieStore almacenCookies) {
		mCookies = almacenCookies.getCookies();
		BasicCookieStore mCS = new BasicCookieStore();
		Iterator<Cookie> it = mCookies.iterator();
		mCookies = new ArrayList<Cookie>(); // Inicializamos...
		while (it.hasNext()) {
			this.AddCookie(it.next());
		}
		httpclient.setCookieStore(mCS);
	}

	public List<Cookie> getAlmacenCookies() {
		Log.i("UOC","getAlmacenCookies: Retornamos: "+mCookies.size()+" cookies.");
		return mCookies;
	}

	public void setUrl(String url) {		
		if ((!url.startsWith("http://")) && (!url.startsWith("https://"))) 
		{url="http://"+url;} // Si por olvido del usuario no tiene protolo, lo aadimos.

		url=url.replaceAll("\r",""); // Eliminamos caracteres que por error pueden haber sido teclados
		url=url.replaceAll("\n",""); // Eliminamos caracteres que por error pueden haber sido teclados

		sUrl = url;
	}

	public String getUrl() {
		return sUrl;
	}

	public void deleteParams() {
		lParametrosPost.clear();
	}

	public void addParam(String param, String value) {
		lParametrosPost.add(new BasicNameValuePair(param, value));
	}

	public boolean doPost() {

		Log.i("UOC", "doPost: " + sUrl);

		HttpPost httpost = null;

		try {
			// 10 Segundos de timeout...
			httpost = new HttpPost(sUrl);
			HttpConnectionParams.setConnectionTimeout(httpost.getParams(), 10000); 			
			httpost.setEntity(new UrlEncodedFormEntity(lParametrosPost, HTTP.UTF_8));
		} catch (UnsupportedEncodingException e) {
			Toast.makeText(mContext, R.string.ErrorURL, Toast.LENGTH_LONG).show();
			return false;
		}		
		catch (Exception e) { // Por si se quieren capturar otros errores con otros mensajes...
			Toast.makeText(mContext, R.string.ErrorURL, Toast.LENGTH_LONG).show();
			return false;
		}


		DefaultHttpClient httpclient = new DefaultHttpClient();
		HttpResponse response=null;
		HttpEntity entity=null;

		/////////////////////////////////// Para usar proxy...
		// Por problemas con el SDK de deja para la siguiente versin
		// Ya que si una URL https es accedida mediante proxy no funciona.
		// http://code.google.com/p/android/issues/detail?id=2690
		//HttpHost httpproxy = new HttpHost("IP", Port); 
		//httpclient.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, httpproxy);
		//////////////////////////////////// PROXY

		try {
			response = httpclient.execute(httpost);
			entity = response.getEntity();
			sPage = EntityUtils.toString(entity);
			convertir(); // Corregimos encoding.
		} catch (ClientProtocolException e) {
			Toast.makeText(mContext, R.string.ErrorProtocol, Toast.LENGTH_LONG).show();
			return false;
		} catch (IOException e) {
			Toast.makeText(mContext, R.string.ErrorIO, Toast.LENGTH_LONG).show();
			return false;
		}
		Log.i("UOC", "doPost: Obtenemos las cookies de la respuesta...");

		if (sUrl.contains("://cv.uoc.edu/")) // Aadimos las cookies si son del dominio de la UOC.
		{
			List<Cookie> cookies = httpclient.getCookieStore().getCookies();
			if (cookies.isEmpty()) {
				Log.i("UOC", "doPost: La peticin no retorna cookies.");
			} else {
				Log.i("UOC", "doPost: La peticin retorna cookies.");
				for (int i = 0; i < cookies.size(); i++) {
					Log.i("UOC", "doPost: Cookie:" + cookies.get(i).toString());
					this.AddCookie((Cookie) cookies.get(i));
				}
			}
		}
		Log.i("UOC", "doPost: Fin post.");
		return true; // Todo fu bien...
	}

	// Retorna la ltima pgina obtenida
	public String getPage() {
		return sPage;
	}

	// Realiza una peticin de tipo GET a la URL
	public boolean doGet() {

		Log.i("UOC", "doGet: " + sUrl);
		HttpResponse response = null;
		HttpEntity entity = null;

		try{
			// 10 Segundos de timeout...
			HttpGet httpget=null;
			httpget = new HttpGet(sUrl);
			HttpConnectionParams.setConnectionTimeout(httpget.getParams(), 10000); 
			
			/////////////////////////////// PROXY
			// Por problemas con el SDK de deja para la siguiente versin
			// Ya que si una URL https es accedida mediante proxy no funciona.
			// http://code.google.com/p/android/issues/detail?id=2690
			//HttpHost httpproxy = new HttpHost("IP", Port); 
			//httpclient.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, httpproxy);
			/////////////////////////////// PROXY


			BasicCookieStore mCS = new BasicCookieStore();

			if (sUrl.contains("://cv.uoc.edu/")) // Aadimos las cookies si son del dominio de la UOC.
			{
				Iterator<Cookie> it = mCookies.iterator();
				while (it.hasNext()) {
					Cookie mC= it.next();				
					mCS.addCookie(mC);
					Log.i("UOC", "doGet: Cookie httpclient:" +mC.toString());
				}
				httpclient.setCookieStore(mCS);
			}
			Log.i("UOC","doGet: Vamos a solicitar:"+sUrl);

			response = httpclient.execute(httpget);
			Log.i("UOC","doGet: Hecho.");			
			entity = response.getEntity();
			Log.i("UOC","doGet: Respuesta...");
		} catch (ClientProtocolException e) {
			Log.i("UOC",e.getStackTrace().toString());
			Toast.makeText(mContext, R.string.ErrorProtocol, Toast.LENGTH_LONG).show();
			return false;
		} catch (IOException e) {
			Log.i("UOC",e.getStackTrace().toString());
			Toast.makeText(mContext, R.string.ErrorIO, Toast.LENGTH_LONG).show();
			return false;
		}
		catch (Exception e) {  // Por si se quieren capturar otros errores con otros mensajes...
			Log.i("UOC",e.getStackTrace().toString());
			Toast.makeText(mContext, R.string.ErrorIO, Toast.LENGTH_LONG).show();
			return false;
		}

		sPage="";

		if (entity != null) {
			try{
				sPage = EntityUtils.toString(entity);
				convertir(); // Corregimos encoding.
			} catch (IOException e) {
				Log.i("UOC",e.getStackTrace().toString());
				Toast.makeText(mContext, R.string.ErrorIO, Toast.LENGTH_LONG)
				.show();
				return false;
			}
		}


		// Obtenemos las cookies que retorne...
		if (sUrl.contains("://cv.uoc.edu/")) // Slo si son del dominio de la UOC.
		{
			List<Cookie> cookies = httpclient.getCookieStore().getCookies();

			if (cookies.isEmpty()) {
				Log.i("UOC", "doGet: La peticin no retorna cookies.");
			} else {
				Log.i("UOC", "doGet: La peticin retorna cookies.");
				for (int i = 0; i < cookies.size(); i++) {
					Log.i("UOC", "doGet: Recibimos Cookie:" + cookies.get(i).toString());
					this.AddCookie((Cookie) cookies.get(i));
				}
			}
		}
		return true;
	}

	// Algunos servidores codifican mal las respuestas, este mtodo es para corregirlo.
	private void convertir(){ // Se irn aadiendo mas segn se vayan detectando otras
		sPage=sPage.replaceAll("á","");
		sPage=sPage.replaceAll("é","");
		sPage=sPage.replaceAll("í","");
		sPage=sPage.replaceAll("ó","");		
		sPage=sPage.replaceAll("ú","");
		sPage=sPage.replaceAll("ñ","");
		sPage=sPage.replaceAll("á","");
		sPage=sPage.replaceAll("é","");
		sPage=sPage.replaceAll("í","");
		sPage=sPage.replaceAll("ó","");
		sPage=sPage.replaceAll("ú","");
		sPage=sPage.replaceAll("ñ","");		 
	}
	
	public void cerrar() {
		httpclient.getConnectionManager().shutdown();
	}

	public void setSessionUOC(String valor) {
		sessionUOC = valor;
	}

	public String getSessionUOC() {
		return sessionUOC;
	}
}
