package edu.uoc.android.uocapp.util;

import java.util.ArrayList;

import android.app.ListActivity;
import android.util.Log;
import edu.uoc.android.uocapp.R;
import edu.uoc.android.uocapp.beans.CadenaPosicion;
import edu.uoc.android.uocapp.beans.Contenido;

import org.json.JSONArray;
import org.json.JSONObject;


public class Parser {

	private boolean nuevosCorreos=false;
	private boolean nuevosMensajes=false;
	private String UOCSession = "";
	private ListActivity mListAct=null;
	private String urlExtra="";

	public Parser(ListActivity la, String sesion)
	{
		this.UOCSession=sesion;	
		this.mListAct=la;
	}

	public String getUrlExtra() {
		return urlExtra;
	}

	public void setUrlExtra(String urlExtra) {
		this.urlExtra = urlExtra;
	}

	public ArrayList<Contenido> ObtenerContenidos(String sPage)
	{

		ArrayList<Contenido> cnt = new ArrayList<Contenido>();
		int inicio=0;
		int fin=0;

		sPage=sPage.replaceAll("\r","");
		sPage=sPage.replaceAll("\n","");

		// Empezamos por el buzn personal
		CadenaPosicion CP = Obtener(sPage,"document.write(missatges(",0,")");
		if (CP.getPosicion()>0) // Buzn encontrado...
		{
			Contenido c = new Contenido();				
			Log.i("UOC","ObtenerContenidos: Buzon personal - Emails sin leer:" +CP.getCadena());
			if (Integer.parseInt(CP.getCadena())>0)
			{this.nuevosCorreos=true;}
			else
			{this.nuevosCorreos=false;}

			c.setsTitulo((String)mListAct.getText(R.string.BuzonPersonal));
			c.setsSubtitulo((String)mListAct.getText(R.string.MensajesNoLeidos)+": "+CP.getCadena());
			c.setsURL("https://cv.uoc.edu/UOC2000/b/cgi-bin/ma_mainMailFS?s="+this.UOCSession);
			cnt.add(c);
		}
		else
		{
			Log.i("UOC","ObtenerContenidos: No se ha encontrado Buzon personal");
		}

		// Seguimos con el calendario
		CP = Obtener(sPage,"document.write(agenda(",0,")");
		if (CP.getPosicion()>0) // Calendario encontrado...
		{
			Contenido c = new Contenido();				
			Log.i("UOC","ObtenerContenidos: Calendario - Citas semanales:" +CP.getCadena());
			c.setsTitulo((String)mListAct.getText(R.string.Calendario));
			c.setsSubtitulo((String)mListAct.getText(R.string.CitasSemanales)+": "+CP.getCadena());
			c.setsURL("https://cv.uoc.edu/webapps/Agenda/NavigationServlet?s="+this.UOCSession);
			cnt.add(c);
		}
		else
		{
			Log.i("UOC","ObtenerContenidos: No se ha encontrado Calendario");
		}
		// Cada elemento quedar comprendido entre "{title...}"

		this.nuevosMensajes=false;

		do
		{
			inicio= sPage.indexOf("]},{title:", fin);
			if (inicio>0)
			{
				Log.i("UOC","ObtenerContenidos: marca de inicio encontrada en:"+inicio);
				fin = sPage.indexOf("[]},{title:", inicio);	
				if (fin<0) 
				{					
					fin=sPage.length(); // El ltimo
					Log.i("UOC","ObtenerContenidos: no se encuentra final, longitud total: "+ sPage.length()+ " debe ser el ltimo, cortaremos desde:"+inicio+" hasta:"+fin);
				}
				else
				{
					Log.i("UOC","ObtenerContenidos: Se encuentra final, cortaremos desde:"+inicio+" hasta:"+fin);
				}
				String cadena = sPage.substring(inicio, fin);
				if (cadena.indexOf("domaintypeid: 'ASSIGNATURA'")<0)
				{
					Log.i("UOC","ObtenerContenidos: Antes de Add...");
					Contenido ct = separar(cadena); // Por claridad lo hacemos en un mtodo aparte
					if (!ct.getsTitulo().equals("NO_ENCONTRADO"))
					{
						Log.i("UOC","ObtenerContenidos: Metemos a los contenidos:" + ct.getsTitulo());
						cnt.add(ct);
					}
					Log.i("UOC","ObtenerContenidos: Despues de Add...");
				}
			}
		}
		while (inicio > 0);

		// Obtenemos contenidos extras de sitio externo
		Log.i("UOC","ObtenerContenidos: ContenidosExtra: '"+this.urlExtra+"'");
		if (!urlExtra.equals(""))
		{ // Existe la URL de Contenidos Extra, obtenemos lo que contiene...
			BrowserUOC mBrowser = new BrowserUOC(mListAct);
			mBrowser.setUrl(urlExtra);
			mBrowser.doGet();
			String OpcionesExtra = mBrowser.getPage();
			
			mBrowser.cerrar();
			// El formato de opciones extra ser: Titulo:Valor, Subtitulo:Valor, URL:Valor
			try      
			{      	
				CadenaPosicion ElArray = Obtener(OpcionesExtra,"[",0,"]");
				JSONArray objetos =null;
				if (ElArray.getPosicion()>0)
				{
					String OExtra = "["+ElArray.getCadena()+"]";
					Log.i("UOC","ObtenerContenidos: ContenidosExtra: ServiciosExtra:"+OExtra);
					objetos = new JSONArray(OExtra);
				}
				else
				{
					Log.i("UOC","ObtenerContenidos: ContenidosExtra: ServiciosExtra:"+OpcionesExtra);
					objetos = new JSONArray(OpcionesExtra);
				}
					

				Log.i("UOC","ObtenerContenidos: ContenidosExtra: Descargados:"+objetos.length()+" elementos.");
				for (int i=0;i<objetos.length();i++)
				{
					JSONObject cont = objetos.getJSONObject(i);

					Contenido ct = new Contenido();
					ct.setsTitulo(cont.getString("titulo"));		    			
					ct.setsSubtitulo(cont.getString("subtitulo"));		    		
					String urlObtenida=cont.getString("URL");
					urlObtenida = urlObtenida.replace("$SESSION$", this.UOCSession);
					ct.setsURL("https://cv.uoc.edu/"+urlObtenida);
					cnt.add(ct);
				}
			}       
			catch(Exception e)       
			{           
				Log.i("UOC", "Error: " + e.getMessage());       
			}		       					
		}
		return cnt;		
	}

	// El mtodo se pone aparte nicamente por claridad

	private Contenido separar(String cadena)
	{
		// Obtenemos el ttulo:

		Log.i("UOC", "Contenido: Separar: " + cadena);		
		Contenido c = new Contenido();				

		c.setsTitulo("NO_ENCONTRADO"); // Establecemos un valor inicial

		CadenaPosicion CP = Obtener(cadena,"{title: '",0,"'");
		if (CP.getPosicion()>0) // Algo encontrado...
		{
			Log.i("UOC","Contenido: Title encontrado:" +CP.getCadena());
			c.setsTitulo(CP.getCadena());

			CP = Obtener(cadena,", code: '",CP.getPosicion(),"'");
			if (CP.getPosicion()>0) // Algo encontrado...
			{
				Log.i("UOC","Contenido: Code Encontrado:" +CP.getCadena());
				c.setsURL("https://cv.uoc.edu/webapps/classroom/031_common/index.jsp?s="+this.UOCSession+"&domainCode="+CP.getCadena()+"&img=aules");
			}

			CP = Obtener(cadena,", domaintypeid: '",CP.getPosicion(),"'");
			if (CP.getPosicion()>0) // Algo encontrado...
			{
				Log.i("UOC","Contenido: Type Encontrado:" +CP.getCadena());
				c.setsTipo(CP.getCadena());
			}

			// Nos interesan Foro, Tabln y Tabln del profesor
			boolean salir=false;
			do
			{
				CP = Obtener(cadena,"{title: '",CP.getPosicion(),"'");
				if (CP.getPosicion()>0) // Algo encontrado...
				{
					Log.i("UOC","Contenido: Type Encontrado:" +CP.getCadena());
					String tipo=CP.getCadena();
					if (CP.getCadena().equals("Foro") || CP.getCadena().equals("Tabln") || CP.getCadena().equals("Tabln del profesor"))
					{
						// Obtenemos los mensajes...
						CP = Obtener(cadena,"numMesPend: ",CP.getPosicion(),",");
						if (Integer.parseInt(CP.getCadena())>0)
						{this.nuevosMensajes=true;}												
						c.setsSubtitulo(c.getsSubtitulo()+tipo+": " + CP.getCadena());
						CP = Obtener(cadena,"numMesTot: ",CP.getPosicion(),",");
						c.setsSubtitulo(c.getsSubtitulo()+"/" + CP.getCadena()+"\n");

						Log.i("UOC","Contenido: Aado:"+tipo+": " + c.getsSubtitulo());
					}
					// Pasamos al siguiente, pero NO salimos.
				}
				else
				{
					salir=true;
					Log.i("UOC","Contenido: Salimos de separar.");
				}
			}
			while (!salir);
			c.setsTipo(CP.getCadena());
		}
		else
		{
			Log.i("UOC", "Contenido: Titulo NO encontrado... no interesa.");					
		}
		return c;		
	}

	// Mtodo para Obtener una subcadena de sOriginal que empieza por 
	// sInicio y termina por SFin a partir de la posicin posInicio 
	// (de sOriginal).

	private CadenaPosicion Obtener(String sOriginal,String sInicio, int posInicio, String sFin)
	{		
		int inicio=0;
		int fin=0;
		CadenaPosicion CP = new CadenaPosicion();
		inicio= sOriginal.indexOf(sInicio, posInicio);
		if (inicio>0)
		{
			fin = sOriginal.indexOf(sFin, inicio+sInicio.length());	
			if (fin>0) {
				CP.setCadena(sOriginal.substring(inicio+sInicio.length(), fin));			
				CP.setPosicion(fin);
				return CP;
			}
			CP.setCadena("FIN_NO_ENCONTRADA");
			CP.setPosicion(-1);
			return CP;
		}
		CP.setCadena("INICIO_NO_ENCONTRADA");
		CP.setPosicion(-2);
		return CP;
	}

	public boolean hayNuevosCorreos() {
		return nuevosCorreos;
	}

	public boolean hayNuevosMensajes() {
		return nuevosMensajes;
	}

}
