package edu.uoc.uocservicios.service.admin;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

import edu.uoc.uocservicios.persistence.*;


public class uocServiceAdmin extends HttpServlet {

	private static final long serialVersionUID = -6544228691105449366L;

	private static final String NAVIGATION = "/_admin/_admin.jsp"; 

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
	throws ServletException, IOException {
		this.doPost(req, resp);
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
	throws ServletException, IOException {

		String op = req.getParameter("op");
		
		boolean Admin = false;
		try
		{
			Admin = UserServiceFactory.getUserService().isUserAdmin();
		}
		catch (Exception e)
		{op="nouser";}  // El usuario no est logado...

		if (op!=null)
		{
			if (op.equals("nouser"))
			{
		        UserService userService = UserServiceFactory.getUserService();          
		        //String thisURL = req.getRequestURI();         
		        if (req.getUserPrincipal() != null) {             
		        	resp.getWriter().println("<p><b>Acceso a la Administracion de UOC Servicios</b>,<br><br>Vd. ya esta logado en Google Accounts: " +                                          
		        			"<b>"+ req.getUserPrincipal().getName() +"</b></br>" + "Puede cerrar sesin aqu: <a href=\"" +                                          
		        			userService.createLogoutURL(req.getHeader("referer")) +                                          
		        			"\">Salir</a>.</p>");         
		        	} else {             
		        		resp.getWriter().println("<p><b>Acceso a la Administracion de UOC Servicios</b><br><br>Por favor, acceda aqui para logarse: <a href=\"" +                                          
		        				userService.createLoginURL(req.getHeader("referer")) +                                          
		        				"\">Entrar</a>.</p><br>Si desea ver los servicios publicados puede acceder aqui: <a href=\"/serv/extra\">/serv/extra</a>(formato JSON).</p>");         } 
			}
			else if (op.equals("Add"))
			{
				if (Admin)
				{
					Contenido cnt = new Contenido();

					String id =req.getParameter("id");			
					if (id!=null) cnt.setId(id);									
					String Titulo = req.getParameter("titulo");
					if (Titulo!=null) cnt.setTitulo(Titulo);
					String subtitulo = req.getParameter("subtitulo");
					if (subtitulo!=null) cnt.setSubtitulo(subtitulo);
					String URL = req.getParameter("URL");
					if (URL!=null) cnt.setURL(URL);

					String activoDesde = req.getParameter("activoDesde");

					// Establecemos un valor "por defecto" para que si luego deseamos modificarlo sea posible.
					SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
					try {
						cnt.setActivoDesde (formatter.parse("1/1/1900"));
					} catch (ParseException e1) {
						e1.printStackTrace();
					}

					if (activoDesde!=null) {

						try {
							cnt.setActivoDesde (formatter.parse(activoDesde));
						} catch (ParseException e) {
							e.printStackTrace();
						}				
					}

					String activoHasta = req.getParameter("activoHasta");
					// Establecemos un valor "por defecto" para que si luego deseamos modificarlo sea posible.
					formatter = new SimpleDateFormat("dd/MM/yyyy");
					try {
						cnt.setActivoHasta (formatter.parse("1/1/2900"));
					} catch (ParseException e1) {
						e1.printStackTrace();
					}

					if (activoHasta!=null) 
					{
						try {
							cnt.setActivoHasta (formatter.parse(activoHasta));
						} catch (ParseException e) {
							e.printStackTrace();
						}				
					}

					String forzarActivo = req.getParameter("forzarActivo");
					cnt.setForzarActivo(Boolean.FALSE);
					if (forzarActivo!=null && forzarActivo.equals("forzarActivo")) cnt.setForzarActivo(Boolean.TRUE);

					ServiciosUtils.insert(cnt);
					resp.sendRedirect(NAVIGATION);
				}
				resp.getWriter().print ("No autorizado a usar estar funcionalidad (Vd. No es Admin).");
			}

			else
			{

				resp.getWriter().print ("Operacion desconocida ("+op+")");
			}
		}
		else
		{
			resp.getWriter().print ("Operacion no definida.");			
		}
	}

}


